/**
 * Mapasuta
 *
 * Copyright (C) 2006 Dominik Winter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 **/
package mapasuta.build.maven.plugin.oaw;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;

/**
 * @author Dominik Winter
 *
 */
public class LogAdapter
    implements Log
{

    private List errors = new ArrayList( 5 );

    private List exceptions = new ArrayList( 5 );

    private static org.apache.maven.plugin.logging.Log mavenLog;

    /**
     * 
     */
    public LogAdapter()
    {
        super();
        // TODO Auto-generated constructor stub
    }
    
    public LogAdapter(String log)
    {
       
    }

    public LogAdapter( org.apache.maven.plugin.logging.Log log )
    {
        setMavenLog( log );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#isDebugEnabled()
     */
    public boolean isDebugEnabled()
    {
        return mavenLog.isDebugEnabled();
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#isErrorEnabled()
     */
    public boolean isErrorEnabled()
    {
        return mavenLog.isErrorEnabled();
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#isFatalEnabled()
     */
    public boolean isFatalEnabled()
    {
        return isErrorEnabled();
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#isInfoEnabled()
     */
    public boolean isInfoEnabled()
    {
        return mavenLog.isInfoEnabled();
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#isTraceEnabled()
     */
    public boolean isTraceEnabled()
    {
        return isDebugEnabled();
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#isWarnEnabled()
     */
    public boolean isWarnEnabled()
    {
        return mavenLog.isWarnEnabled();
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#trace(java.lang.Object)
     */
    public void trace( Object arg0 )
    {
        debug( arg0 );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#trace(java.lang.Object, java.lang.Throwable)
     */
    public void trace( Object arg0, Throwable arg1 )
    {
        debug( arg0, arg1 );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#debug(java.lang.Object)
     */
    public void debug( Object arg0 )
    {
        mavenLog.debug( arg0.toString() );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#debug(java.lang.Object, java.lang.Throwable)
     */
    public void debug( Object arg0, Throwable arg1 )
    {
        mavenLog.debug( arg0.toString(), arg1 );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#info(java.lang.Object)
     */
    public void info( Object arg0 )
    {
        mavenLog.info( arg0.toString() );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#info(java.lang.Object, java.lang.Throwable)
     */
    public void info( Object arg0, Throwable arg1 )
    {
        mavenLog.info( arg0.toString(), arg1 );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#warn(java.lang.Object)
     */
    public void warn( Object arg0 )
    {
        mavenLog.warn( arg0.toString() );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#warn(java.lang.Object, java.lang.Throwable)
     */
    public void warn( Object arg0, Throwable arg1 )
    {
        mavenLog.warn( arg0.toString(), arg1 );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#error(java.lang.Object)
     */
    public void error( Object arg0 )
    {
        errors.add( arg0 );
        mavenLog.error( arg0.toString() );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#error(java.lang.Object, java.lang.Throwable)
     */
    public void error( Object arg0, Throwable arg1 )
    {
        errors.add( arg0 );
        exceptions.add( arg1 );
        mavenLog.error( arg0.toString(), arg1 );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#fatal(java.lang.Object)
     */
    public void fatal( Object arg0 )
    {
        error( arg0 );
    }

    /* (non-Javadoc)
     * @see org.apache.commons.logging.Log#fatal(java.lang.Object, java.lang.Throwable)
     */
    public void fatal( Object arg0, Throwable arg1 )
    {
        error( arg0, arg1 );
    }

    /**
     * @return Returns the mavenLog.
     */
    org.apache.maven.plugin.logging.Log getMavenLog()
    {
        return mavenLog;
    }

    /**
     * @param mavenLog The mavenLog to set.
     */
    static void setMavenLog( org.apache.maven.plugin.logging.Log mvnLog )
    {
        mavenLog = mvnLog;
    }

    /**
     * @return Returns the errors.
     */
    String getErrors()
    {
        StringBuffer buff = new StringBuffer( errors.size() );
        for ( Iterator i = errors.iterator(); i.hasNext(); )
            buff.append( i.next() ).append( System.getProperty( "line.separator" ) );
        return buff.toString();
    }

    /**
     * @return Returns the exceptions.
     */
    List getExceptions()
    {
        return exceptions;
    }

}
