/**
 * Mapasuta
 *
 * Copyright (C) 2006 Dominik Winter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 **/
package mapasuta.build.maven.plugin.oaw;


/**
 * Runs a workflow file.
 * 
 * @author Dominik Winter
 * @goal run-workflow
 * @phase generate-sources
 * @requiresDependencyResolution compile
 */
public final class OpenArchitectureWareMojo extends AbstractOawMojo
{

   /**
    * Output directory. Will be automagically added as property "outputDir" to the
    * workflow parameters to be used for the default outlet.
    * 
    * @parameter expression="${project.build.directory}/generated-sources/maven-oaw-plugin/"
    * @required
    */
   private String outputDir = null;
   
   /**
    * @param outputDir
    *           the outputDir to set
    */
   protected final void setOutputDir(String outputDir)
   {
      this.outputDir = outputDir;
   }

   protected final String getOutputDir()
   {
      return outputDir;
   }

   protected final void setSourceRoot(final String sourceRoot)
   {
      if (getProject() != null) // for JUnit test
         getProject().addCompileSourceRoot(sourceRoot);
   }

}
